This is a live mirror of the Perl 5 development currently hosted at https://github.com/perl/perl5
Tweaking the order of op creation/op free in Perl_ck_require to Larry's
[perl5.git] / ext / util / make_ext
index ae10a9d..8bcd7d8 100644 (file)
@@ -4,16 +4,35 @@
 # It primarily used by the perl Makefile:
 #
 # d_dummy $(dynamic_ext): miniperl preplibrary FORCE
-#        ext/util/make_ext dynamic $@
+#      @sh ext/util/make_ext dynamic $@ MAKE=$(MAKE) LIBPERL_A=$(LIBPERL)
 #
 # It may be deleted in a later release of perl so try to
 # avoid using it for other purposes.
 
 target=$1;  shift
 extspec=$1; shift
+makecmd=$1; shift  # Should be something like MAKE=make
 passthru="$*" # allow extra macro=value to be passed through
 echo ""
 
+# Previously, $make was taken from config.sh.  However, the user might
+# instead be running a possibly incompatible make.  This might happen if
+# the user types "gmake" instead of a plain "make", for example.  The
+# correct current value of MAKE will come through from the main perl
+# makefile as MAKE=/whatever/make in $makecmd.  We'll be cautious in
+# case third party users of this script (are there any?) don't have the
+# MAKE=$(MAKE) argument, which was added after 5.004_03.
+case "$makecmd" in
+MAKE=*)
+       eval $makecmd
+       ;;
+*)     echo 'ext/util/make_ext:  WARNING:  Please include MAKE=$(MAKE)'
+       echo '  in your call to make_ext.  See ext/util/make_ext for details.'
+       exit 1
+       ;;
+esac
+
+
 case $CONFIG in
 '')
     if test -f config.sh; then TOP=.;
@@ -34,14 +53,16 @@ if test "X$extspec" = X; then
 fi
 
 # The Perl Makefile.SH will expand all extensions to
-#      lib/auto/X/X.a  (or lib/auto/X/Y/Y.a is nested)
+#      lib/auto/X/X.a  (or lib/auto/X/Y/Y.a if nested)
 # A user wishing to run make_ext might use
-#      X (or X/Y or X::Y is nested)
+#      X (or X/Y or X::Y if nested)
 
 # canonise into X/Y form (pname)
 case "$extspec" in
 lib*)  # Remove lib/auto prefix and /*.* suffix
        pname=`echo "$extspec" | sed -e 's:^lib/auto/::' -e 's:/[^/]*\.[^/]*$::' ` ;;
+ext*)  # Remove ext/ prefix and /pm_to_blib suffix
+       pname=`echo "$extspec" | sed -e 's:^ext/::' -e 's:/pm_to_blib$::' ` ;;
 *::*)  # Convert :: to /
        pname=`echo "$extspec" | sed -e 's/::/\//g' ` ;;
 *)     pname="$extspec" ;;
@@ -50,7 +71,6 @@ esac
 
 mname=`echo "$pname"   | sed -e 's!/!::!g'`
 depth=`echo "$pname"   | sed -e 's![^/][^/]*!..!g'`
-make=${altmake-make}
 makefile=Makefile
 makeargs=''
 makeopts=''
@@ -65,13 +85,20 @@ echo "      Making $mname ($target)"
 
 cd ext/$pname
 
-# check link type and do any preliminaries
+# check link type and do any preliminaries.  Valid link types are
+# 'dynamic', 'static', and 'static_pic' (the last one respects
+# CCCDLFLAGS such as -fPIC -- see static_target in the main Makefile.SH)
 case "$target" in
-           # convert 'static' or 'dynamic' into 'all LINKTYPE=XXX'
+dynamic)    makeargs="LINKTYPE=dynamic";
+           target=all
+           ;;
 static)     makeargs="LINKTYPE=static CCCDLFLAGS="
            target=all
            ;;
-dynamic)    makeargs="LINKTYPE=dynamic";
+static_pic) makeargs="LINKTYPE=static"
+           target=all
+           ;;
+nonxs)      makeargs="";
            target=all
            ;;
 
@@ -92,7 +119,7 @@ dynamic)    makeargs="LINKTYPE=dynamic";
 esac
 
 if test ! -f $makefile ; then
-       test -f Makefile.PL && ../$depth/miniperl -I../$depth/lib Makefile.PL
+       test -f Makefile.PL && ../$depth/miniperl -I../$depth/lib Makefile.PL INSTALLDIRS=perl PERL_CORE=1 $passthru
 fi
 if test ! -f $makefile ; then
        if test -f Makefile.SH; then
@@ -108,10 +135,10 @@ clean)            ;;
 realclean)     ;;
 *)     # Give makefile an opportunity to rewrite itself.
        # reassure users that life goes on...
-       $make config $passthru || echo "$make config failed, continuing anyway..."
+       $MAKE config $passthru || echo "$MAKE config failed, continuing anyway..."
        ;;
 esac
 
-$make $makeopts $target $makeargs $passthru || exit
+$MAKE $makeopts $target $makeargs $passthru || exit
 
 exit $?